/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();
        
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        
        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Select gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i=0; i<$Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cicle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set enable history
        $Elem = $("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
        
        /** Ghost updates */
        
        //Set linked with (ghost scenario type)
        $Elem = $("[eve-manager-protocol='ghost'] .linkedwith");
        var oComposition = oComponent.getParamVal("ghost");
        
        if(oComposition != undefined && oComposition.attached != undefined && oComposition.attached.UId != undefined){
            var oAttachedNode = application.getComponentByUid( oComposition.attached.UId );

            if(oAttachedNode != undefined){
                var oAttachedComponent = oAttachedNode.getData();
                var oParentAttachedNode = oAttachedNode.getParent();
                var oAttachedParent = oParentAttachedNode.getData();
                var strAtt = (oAttachedParent.getParamVal)?oAttachedParent.getParamVal("name"):_D("none");
                strAtt += " - ";
                strAtt += oAttachedComponent.getParamVal("name");
                $Elem.text(strAtt);
            }
            else{
                oComposition.attached = undefined;
                console.warn("Attached component don't exist anymore");
            }
        }

        
        //Set linked with (ghost scenario type)
        $Elem = $("[eve-manager-protocol='ghost'] .actions");
        if(oComposition != undefined && oComposition.actions != undefined){
            var strHtml = "";
            var oActions = oComposition.actions;

            var index = 0;
            while(index < oActions.length){
                //console.warn(oActions[index]);
                var oTempNode = application.getComponentByUid( oActions[index].UId );

                if(oTempNode == undefined){
                    console.warn("Action component don't exist anymore");
                    oActions.splice(index,1);
                    continue;
                }
                else{
                    var oTempComponent = oTempNode.getData();
                    var oTempParent = oTempNode.getParent();
                    var oTempParentComponent = oTempParent.getData();
                    var oTempDescriptor = oTempComponent.getDescriptor();

                    strHtml +=  "<li>"+
                        "<span>"+ ((oTempParentComponent.getParamVal != undefined)?oTempParentComponent.getParamVal("name"):_D("none")) +"</span>"+
                        "<span>"+ oTempComponent.getParamVal("name") +"</span>"+
                        //"<span>"+ oTempComponent.getDescriptor().getDescriptionByValue(oActions[index].action) +"</span>"+
                        "<span>"+ oTempDescriptor.getDescriptionByValue(oActions[index].action) +"</span>"+
                        "<span>"+ oActions[index].value +"</span>"+
                        "</li>";
                    ++index;
                }
            }
        }
        $Elem.html(strHtml);
        //FUNZIONE RESPONSABILE DI MODIFICARE TUTTI I PARAMETRI DEL COMPONENTE HTML

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );



        updateCustomData(oComponent);

        $Elem = $componentProperties.find("[eve-manager-id='gui/start-delay']");
        $Elem.val(oComponent.getParamVal("gui/start-delay"));


    };
}
catch(err){
    console.error(err);
}
