/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);

        onDeselect = function () {
            $("#mycomponents .extra").hide();
            return true;
        }

        onSelect = function () {
            $("#mycomponents .extra").show();

            return true;
        }

        //Set default values
        oComponent.addParamVal("name",_D("Scenario")+" "+oComponent.UId);
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.Scenario.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		,{id:3, label:"Hidden"} 
        	]);
        
        oComponent.addParamVal("value",0);
        
        // KNX
        oComponent.addParamVal("knx/write-address","//");
        oComponent.addParamVal("knx/functional-block",8);
        oComponent.addParamVal("knx/scene-value","");
        oComponent.addParamVal("knx/virtual-feedback",false);
        
        // Ghost
        oComponent.addParamVal("ghost",new Object());
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");
        
        // Datagram
        oComponent.addParamVal("datagram/hex-char","");
        oComponent.addParamVal("datagram/command","");
        oComponent.addParamVal("datagram/broadcast",false);

        // Http
        oComponent.addParamVal("http/path","");
        oComponent.addParamVal("http/response","");
        
        // Vimar
        oComponent.addParamVal("vimar/group-address","");
        oComponent.addParamVal("vimar/value","");
        oComponent.addParamVal("vimar/physical-addresses","");

        oComponent.addParamVal("vimar/enable-sfbk",false);
        oComponent.addParamVal("vimar/sfbk","//");
        
        //Vivaldi
		oComponent.addParamVal("vivaldi/device-pid",1);
        oComponent.addParamVal("vivaldi/device-id",1);
        oComponent.addParamVal("vivaldi/device-fid",0);
        oComponent.addParamVal("vivaldi/value", 1);

        // Vivaldi Giove Free
        oComponent.addParamVal("vivaldigiovefree/device-id", 1);
        oComponent.addParamVal("vivaldigiovefree/device-fid", 8);
        oComponent.addParamVal("vivaldigiovefree/value", 1);
        
        //BTicino
       	oComponent.addParamVal("bticino/who", "none");
        oComponent.addParamVal("bticino/interface","none");
        oComponent.addParamVal("bticino/address","none");
        oComponent.addParamVal("bticino/function","none");
        oComponent.addParamVal("bticino/value","none");

        //ModbusTCP
        oComponent.addParamVal("modbustcp/read-unit-id",0);
        oComponent.addParamVal("modbustcp/read-function-id",3);
        oComponent.addParamVal("modbustcp/read-register-start",0);
        oComponent.addParamVal("modbustcp/read-register-count",1);
        oComponent.addParamVal("modbustcp/read-bit-start",-1);
        oComponent.addParamVal("modbustcp/read-bit-count",0);
        oComponent.addParamVal("modbustcp/read-transform-type",4);
        oComponent.addParamVal("modbustcp/read-transform-min",0);
        oComponent.addParamVal("modbustcp/read-transform-max",65535);
        oComponent.addParamVal("modbustcp/read-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/write-unit-id",0);
        oComponent.addParamVal("modbustcp/write-function-id",6);
        oComponent.addParamVal("modbustcp/write-register-start",0);
        oComponent.addParamVal("modbustcp/write-register-count",1);
        oComponent.addParamVal("modbustcp/write-bit-start",-1);
        oComponent.addParamVal("modbustcp/write-bit-count",0);
        oComponent.addParamVal("modbustcp/write-transform-type",4);
        oComponent.addParamVal("modbustcp/write-transform-min",0);
        oComponent.addParamVal("modbustcp/write-transform-max",65535);
        oComponent.addParamVal("modbustcp/write-transform-multiplier",1.0);

        //ModbusRTUTCP
        oComponent.addParamVal("modbusrtutcp/read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-type",4);
        oComponent.addParamVal("modbusrtutcp/read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-max",65535);
        oComponent.addParamVal("modbusrtutcp/read-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-type",4);
        oComponent.addParamVal("modbusrtutcp/write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-max",65535);
        oComponent.addParamVal("modbusrtutcp/write-transform-multiplier",1.0);
    };
}
catch(err){
    console.error(err);
}
