﻿/**
 * Eve Manager Dictionary
 *
 * Author: Matteo Casagrande
 *
 */
"usestrict";

function Dictionary(){
	//Build singleton instance
	if(arguments.callee._singletonInstance){
		return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	//Attributes
	var self = this;
	var m_mapDictionary = undefined;
	var m_languageId = "en";
	
	/**
		Language Id
		
		en -> English
		it -> Italian
	*/
	
	/** Set and load dictionary by language Id
	 * @param {string} languageId Language Id (eg. en for English, it for Italian)
	 * @returns {string} New language Id
	 */
	this.setLanguage = function(languageId){
		//console.log("%c"+ languageId,"color: orange");
		/*if(m_mapDictionary == undefined || m_mapDictionary["language-id"] != languageId){
			m_languageId = languageId;
			self.loadDictionary(m_languageId);
		}
		else{
			console.log("Has been required same already loaded language. No loading will be performed.");
		}*/
		m_languageId = languageId.toLowerCase();
		self.loadDictionary(m_languageId);
		return m_languageId;
	};
	
	/** Get current language Id
     * @returns {string} Language Id
     */
	this.getLanguage = function(){
	    return m_languageId;
	};
	
	/** Get translation of name
	 * @param {string} strKey Word or phrase to translate
	 * @returns {string} Translation of input string
	 */
	this.getName = function(strKey){
		//Append in queue waiting loaded file
		if(m_mapDictionary == undefined){
			console.error("Any language map is loaded");
			return;
		}
		//Return from loaded map
		else{
			if(m_mapDictionary[strKey] == undefined){
				//console.warn("Any traduction defined for '%c"+ strKey +"%c'","color:red","color:black");
				return strKey;
			}
			else{
			    return m_mapDictionary[strKey];
			}
		}
	};
	
	/** Load dictionary JSON map from file
	 * @param {string} id Language Id (eg. en for English)
	 */
	this.loadDictionary = function(id){
		if(m_mapDictionary == undefined || m_mapDictionary["language-id"] != id){
			var url = "./dictionaries/"+ id +".json";
			$.ajax({
				url: "./dictionaries/"+ id +".json",
				async: false,
				cache: false,
				dataType: "json",
				error: function(jqXHR,textStatus,textStatus,errorThrown){ console.error(textStatus); },
				complete: function(jqXHR,textStatus,textStatus,errorThrown){ self.onLoadDictionary(m_mapDictionary); },
				success: function(json){ m_mapDictionary = json; console.log("Language %c"+ id +" %cloaded","color:orange","color:black"); }
			});
		}
		else{
			self.onLoadDictionary(m_mapDictionary);
		}
	};
	
	/** Load dictionary JSON map from file
	 * @param {string} id Language Id (eg. en for English)
	 */
	this.onLoadDictionary = function(oMap){
		console.log("Language map loaded, overwrite %conLoadDictionary %cevent if you want to use a loader","color:blue;","color:black;");
	};
	
	/** Translation
     * @param {string} id Language Id (eg. en for English)
     */
    this.translation = function(oJSON){
        console.log("Language map loaded, overwrite %conLoadDictionary %cevent if you want to use a loader","color:blue;","color:black;");
    };
	
	//Init operations
	//console.log("Dictionary class %cinitial operations","color:orange");
	//self.loadDictionary(m_languageId);
}