﻿/**
 * Menu manager for user interface
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 *
 */
"usestrict";

function MenuUIManager(){
	/** Build singleton instance */
	if(arguments.callee._singletonInstance){
		return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;
	
	//Instance variables (private)
	var self = this;
	
	/** Initialize function
	 *
	 */
	var init = function(){
	    //Append menu on document ready
        document.addEventListener("DOMContentLoaded",function(e){
            console.log("%cMenu manager view operations","color:brown;");

            //Load main menu
            $("#header").loadSync("./menu/mainmenu/mainmenu.html");

            //Load context menu - components menu
            $.get(
                "./menu/contextmenu/componentsmenu.html",
                function(data){ $("body").append(data); }
            );
            
            //Load context menu - gateways menu
            $.get(
                "./menu/contextmenu/gatewaysmenu.html",
                function(data){ $("body").append(data);}
            );

            //Load context menu - interface menu
            $.get(
                "./menu/contextmenu/interfacemenu.html",
                function(data){ $("body").append(data);}
            );
            
            //Add context menu on gateways container
            $("#mygateways .gateways")[0].addEventListener("contextmenu",function(e){
                var $menu = $("[eve-manager-mainmenu='gatewaysmenu']");
                var $element = $(e.target);
                var pos= {x: event.clientX,y : event.clientY};


                //   var pos = eveManager.HidManager.cursor;
                
                //Positioning context menu
                $menu.css("top", pos.y +"px");
                $menu.css("left", pos.x +"px");
                
                //Check Y axis menu overflow
                var iOffset = 20; 
                var iWinHeight = $window.height();
                var iMenuBottom = pos.y + $menu.height();
                
                //Menu Y reposition
                if(iWinHeight < iMenuBottom){
                    $menu.css("top", iWinHeight - $menu.height() - iOffset +"px");
                }
                
                //Check target
                if($element.hasClass("gateway") || $element.parents(".gateway").length > 0){
                    var oNode = $element.data("eveManagerNode");
                    
                    if(oNode == undefined){
                        oNode = $element.parents(".gateway").data("eveManagerNode");
                    }

                    //Disable context menu items
                    if(oNode.getData().getParamVal("special") != undefined){
                        $("#remove-gateway").addClass("ui-state-disabled");
                        $menu.find("#copy-gateway").addClass("ui-state-disabled");
                    }
                    else{
                        $("#remove-gateway").data("eveManagerNode",oNode);
                        $("#remove-gateway").removeClass("ui-state-disabled");
                        $menu.find("#copy-gateway").data("eveManagerNode",oNode);
                        $menu.find("#copy-gateway").removeClass("ui-state-disabled");
                    }
                }
                else{
                    $("#remove-gateway").addClass("ui-state-disabled");
                }

                //Check for paste option
                if(model["copied"] != undefined && model["copied"].getData() instanceof Gateway){
                    $menu.find("#paste-gateway").data("eveManagerNode",model["copied"]);
                    $menu.find("#paste-gateway").removeClass("ui-state-disabled");
                }
                else{
                    $menu.find("#paste-gateway").addClass("ui-state-disabled");
                }
                
                //eveManager.MenuUIManager.selectCurrentMenu($menu);
                presenter.menu.selectCurrentMenu($menu);
                e.preventDefault();
            },false);
            
            //Add context menu on components container
            $("#componentscontainer")[0].addEventListener("contextmenu",function(e) {
                var $menu = $("[eve-manager-mainmenu='componentsmenu']");
                // se è un gruppo la posizione relativa del campo data cambia rispetto al target cliccato
                var $element=$(e.target);

                var oNode = $(e.target).data().eveManagerNode;
                if (oNode == undefined)
                    $element=$element.closest("li");
                if ($element.length>0)
                    oNode = $element.data().eveManagerNode;

                if (oNode == undefined) {
                    $element = $(e.target);
                    $element = $element.closest("div");
                }
                oNode = $element.data().eveManagerNode;

                if (oNode == undefined || oNode.getData().m_Data.name=="root"){
                    oNode = $(e.target).data().eveManagerNode;
                }

                View.deselectComponent();
                View.selectComponent(oNode);
                $("#componentscontainer").data("LastMouseOverNode",oNode);
                //var pos = eveManager.HidManager.cursor;
                var pos= {x: event.clientX,y : event.clientY};

                //Positioning context menu
                $menu.css("top", pos.y +"px");
                $menu.css("left", pos.x +"px");
                
                //Check Y axis menu overflow
                var iOffset = 20; 
                var iWinHeight = $window.height();
                var iMenuBottom = pos.y + $menu.height();
                
                //Menu Y reposition
                if(iWinHeight < iMenuBottom){
                    $menu.css("top", iWinHeight - $menu.height() - iOffset +"px");
                }
                
                //Check target
                if($element.attr("id") == "componentscontainer"){
                    $("#removeelement").addClass("ui-state-disabled");
                    $menu.find("#copy-component").addClass("ui-state-disabled");
                    $menu.find("#export").addClass("ui-state-disabled");
                    $menu.find("#duplicate-group").addClass("ui-state-disabled");
                }
                else{
                    $("#removeelement").removeClass("ui-state-disabled");
                    $menu.find("#copy-component").removeClass("ui-state-disabled");

                    /* var oParentNode;
                    var oNode; */

                    /*if($element.data("eveManagerNode") != undefined){
                        oNode = $element.data("eveManagerNode");
                    }
                    else{
                        oNode = $element.parent().data("eveManagerNode");
                    }*/

                    var oNode = ($element.data("eveManagerNode") != undefined)?$element.data("eveManagerNode"):$element.parent().data("eveManagerNode");

                    $menu.find("#copy-component").data("eveManagerNode",oNode);


                    //Check for group
                    var oComponent = oNode.getData();
                    if(oComponent.getType() == "group"){
                        $menu.find("#duplicate-group").removeClass("ui-state-disabled").data("eveManagerNode",oNode);
                        $menu.find("#export").removeClass("ui-state-disabled");
                        $menu.find("#export").data("eveManagerNode",oNode);
                    }
                    else{
                        $menu.find("#duplicate-group").addClass("ui-state-disabled");
                        $menu.find("#export").addClass("ui-state-disabled");
                    }
                }

                //Check for paste option
                if(model["copied"] != undefined && model["copied"].getData() instanceof Component){
                    //$menu.find("#paste-component").data("eveManagerNode",model["copied"]);
                    //console.error( $element.parent().data("eveManagerNode") );
                    //console.error( $element.parent()[0] );
                    var oParentNode;

                    if($element.parent().attr("eve-manager-component") == "group"){
                        oParentNode = $element.parent().data("eveManagerNode");
                    }

                    if(model["copied"] != undefined && model["copied"].getData().getType() == "group"){
                        oParentNode = undefined;
                    }

                    $menu.find("#paste-component").data("eveManagerData",{ component: model["copied"], parent: oParentNode} );
                    $menu.find("#paste-component").removeClass("ui-state-disabled");
                }
                else{
                    $menu.find("#paste-component").addClass("ui-state-disabled");
                }
                
                //eveManager.MenuUIManager.selectCurrentMenu($menu);
                presenter.menu.selectCurrentMenu($menu);
                e.preventDefault();
            },false);

            //Add context menu on interface
            $("#interface-maps .maps-container")[0].addEventListener("contextmenu",function(e){
                var $menu = $("[eve-manager-mainmenu='interfacemenu']");
                var $element = $(e.target);

                //var pos = eveManager.HidManager.cursor;
                var pos= {x: event.clientX,y : event.clientY};
                //Check class or id
                if( ($element.parents(".viewer").length < 1 && !$element.hasClass("viewer")) ){

                    return;
                }

                //Positioning context menu
                $menu.css("top", pos.y +"px");
                $menu.css("left", pos.x +"px");

                //Check Y axis menu overflow
                var iOffset = 20;
                var iWinHeight = $window.height();
                var iMenuBottom = pos.y + $menu.height();

                //Menu Y reposition
                if(iWinHeight < iMenuBottom){
                    $menu.css("top", iWinHeight - $menu.height() - iOffset +"px");
                }

                //Check target
                //console.error($element[0]);

                //console.error($element[0].toString());

         /*       if($element.is("img")){
                    //console.log($element.parents(".viewer").length);
                    $element = $element.parents(".viewer");
                }
*/
                /*if($element[0].toString() == "HTMLImageElement"){
                    console.error($element.parents(".view").length);
                    $element = $element.parents(".view");
                }*/

                //console.warn($element[0]);

                if($element.hasClass("viewer")){
                    //$menu.find("#remove-background").show();
                    var oNode = application.getSelectMap();
                    if(oNode != undefined){
                        var oMap = oNode.getData();

                        if(oMap["background"] == null || oMap["background"].length < 1){
                            $menu.find("#remove-background").addClass("ui-state-disabled");
                        }
                        else{
                            $menu.find("#remove-background").removeClass("ui-state-disabled");
                        }
                        oNode.getData().components[0].getData().name

                    }

                    if(oNode.getData().components[0].getData().name!="Image"){
                        //$("#removeelement").addClass("ui-state-disabled");
                        $menu.find("#copy-element").addClass("ui-state-disabled");
                        $menu.find("#remove-element").addClass("ui-state-disabled");

                        //console.warn(oNode);
                    }
                    else
                    {

                        var oMapNode = application.getSelectMapComponent();
                        $menu.find("#copy-element").data("eveManagerNode",oMapNode);
                        $menu.find("#remove-element").data("eveManagerNode",oMapNode);

                    }

                }
                else{
                    //$menu.find("#remove-background").hide();

                    $menu.find("#copy-element").removeClass("ui-state-disabled");
                    $menu.find("#remove-element").removeClass("ui-state-disabled");

                    var oNode = ($element.data("eveManagerNode") != undefined)?$element.data("eveManagerNode"):$element.parents(".map-element").data("eveManagerNode");

                    //console.warn(oNode);

                    $menu.find("#copy-element").data("eveManagerNode",oNode);
                    $menu.find("#remove-element").data("eveManagerNode",oNode);

                    var oMapNode = application.getSelectMapComponent();
                    if(oMapNode != undefined){
                        $menu.find("#bring-front").data("mapComponent",oMapNode);
                        $menu.find("#bring-forward").data("mapComponent",oMapNode);

                        $menu.find("#send-backward").data("mapComponent",oMapNode);
                        $menu.find("#send-back").data("mapComponent",oMapNode);
                    }
                }

                //Check for paste option
                if(model["copied"] != undefined && model["copied"].getData() instanceof MapComponent){
                    //$menu.find("#paste-component").data("eveManagerNode",model["copied"]);
                    //console.error( $element.parent().data("eveManagerNode") );
                    //console.error( $element.parent()[0] );
                    var oParentNode = application.getSelectMap();

                    $menu.find("#paste-element").data("eveManagerData",{ component: model["copied"], parent: oParentNode} );
                    $menu.find("#paste-element").removeClass("ui-state-disabled");
                }
                else{
                    $menu.find("#paste-element").addClass("ui-state-disabled");
                }

                //eveManager.MenuUIManager.selectCurrentMenu($menu);
                presenter.menu.selectCurrentMenu($menu);
                e.preventDefault();
            },false);
            
        });
        
        //Deselect menu during click on document occurred
        document.addEventListener("click",function(e){
            var $menu = $(e.target).parents("[eve-manager-mainmenu]");

            if($menu.length > 0){
                return;
            }

            self.deselectCurrentMenu();
        });
	};
	
	/** Current opened menu
	 * @public
	 * @default undefined
	 */
	this.m_currentMenu = undefined;
	
	/** Methods */
	this.selectCurrentMenu = function(obj,e){
		
		//Check is jquery object
		if(!obj instanceof jQuery){
            console.error("Not a jQuery object");
        }

        if(obj.hasClass("ui-state-disabled")){
            self.m_currentMenu.hide();
            return;
        }
		
		//Menu selected
		if(self.m_currentMenu){
			//Check if same menu is selected
			if(self.m_currentMenu[0] == obj[0] && e && e.type == "click"){
				self.deselectCurrentMenu();
			}
			else{
				self.m_currentMenu.hide();															//Hide previous menu
				var strSubmenu = self.m_currentMenu.attr("eve-manager-mainmenu");					//Get submenu string
				var $header = $("#header");															//Get header html element
				
				//$("#header").on("mouseout","[eve-manager-mainmenu]",function(e){
				/*$("#header").on("mouseout","[eve-manager-submenu='"+ strSubmenu +"']",function(e){
					$(this).removeClass("ui-state-active").css("border-color","transparent");
				});*/
				
				
				$header.find("[eve-manager-submenu='"+ strSubmenu +"']").removeClass("ui-state-active");
				$header.find("[eve-manager-submenu='"+ strSubmenu +"']").css("border-color","transparent");
				
				self.m_currentMenu = obj;
				obj.show();
				
				strSubmenu = obj.attr("eve-manager-mainmenu");
				
				//$header.off("mouseout","[eve-manager-mainmenu]");									//Disable mouse out event
				$header.off("mouseout","[eve-manager-submenu='"+ strSubmenu +"']");									//Disable mouse out event
				$header.find("[eve-manager-submenu='"+ strSubmenu +"']").addClass("ui-state-active");
				$header.find("[eve-manager-submenu='"+ strSubmenu +"']").css("border-color","#999");
			}
		}
		//Any menu selected
		else{
			self.m_currentMenu = obj;

			obj.show();
			var strSubmenu = obj.attr("eve-manager-mainmenu");
			var $header = $("#header");																//Get header html element
			
			//$header.off("mouseout","[eve-manager-mainmenu]");										//Disable mouse out event
			$header.off("mouseout","[eve-manager-submenu='"+ strSubmenu +"']");										//Disable mouse out event
			$header.find("[eve-manager-submenu='"+ strSubmenu +"']").addClass("ui-state-active");
			$header.find("[eve-manager-submenu='"+ strSubmenu +"']").css("border-color","#999");
		}
	};
	
	/**  */
	this.deselectCurrentMenu = function(){
		if(self.m_currentMenu == undefined){
			return;
		}
		else if(self.m_currentMenu == null){
			self.m_currentMenu = undefined;
			return;
		}
		
		//Menu selected
		if(self.m_currentMenu){
			self.m_currentMenu.hide();
			
			var strSubmenu = self.m_currentMenu.attr("eve-manager-mainmenu");
			$("#header").find("[eve-manager-submenu='"+ strSubmenu +"']").removeClass("ui-state-active").css("border-color","transparent");
			//$("#header").find("[eve-manager-submenu='"+ strSubmenu +"']").css("border-color","transparent");
			self.m_currentMenu = undefined;
		}
	};
	
	//Initialize menu manager
	init();
}