﻿/** Resources Manager Controller: Business logic singleton class
 *
 * @class ResourcesController
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 * @requires jQuery framework
 */
//"use strict";

function ResourcesController(oResourseManager){
	//Build singleton instance
	if ( arguments.callee._singletonInstance ){
        console.warn("Singleton instance used");
        return arguments.callee._singletonInstance;
    }
        
    arguments.callee._singletonInstance = this;
    
	/** Instance variables (private) */
	var self = this;
	
	/** Resource Manager reference
     * 
     */
    var m_oReference = oResourseManager;
    
	/** Initialize private method
     * 
     */
    var init = function(){
        
    };
    
    /**
     * 
     */
    this.addIconsPan = function(oParams){
        var oPan = m_oReference.addSprite( $.extend(false, oParams, {
            "type": "pan/icons"
        }) );

        QT.copyFile(oPan["params"]["src"],"../project/assets/icons/"+ oPan["params"]["name"]);
        if (oPan["params"]["srcSelected"]!="")
            QT.copyFile(oPan["params"]["srcSelected"],"../project/assets/icons/"+"selected_"+ oPan["params"]["name"]);

        if(View.ready){
            return;
        }
        
        View.addIconsPan(oPan);
        
        return;
    };
	
	/**
	 * 
	 */
	this.getDefaultIconsPan = function(argument){
	    return m_oReference.getSpritesByType("pan/icons")[0];
	};
	
	/**
     * 
     */
    this.getIconsPanById = function(id){
        return m_oReference.getSpriteById(id);
    };

    /**
     *
     */
    this.getIconsPans = function(){
        return m_oReference.getSpritesByType("pan/icons");
    };

    /** Initialize */
	init();
}