/**
 * Created by blr on 22/04/15.
 */
"use strict";


/*!
gfx resource
* */
function blrGfxResource() {
    var self = this;
    this.skin = model["instance"].skin;
    this.pan = application.ResoucesManager.getDefaultIconsPan()["id"];
    this.image = { w: model["instance"].skin.IconsPan[0].imgWidth, h: model["instance"].skin.IconsPan[0].imgHeight };
    this.icon = { w: model["instance"].skin.IconsPan[0].iconsWidth, h: model["instance"].skin.IconsPan[0].iconsHeight };
    this.iconsPerRow = Math.floor(model["instance"].skin.IconsPan[0].imgWidth / model["instance"].skin.IconsPan[0].iconsWidth);
    this.iconsPerColumn = Math.floor(model["instance"].skin.IconsPan[0].imgHeight / model["instance"].skin.IconsPan[0].iconsHeight);
    this.getIconByIndex = function (status, index,r,g,b) {
        var x = index % self.iconsPerRow;
        var y = Math.floor(index / self.iconsPerRow);
        var bColorize = false;
        var rgb = { R: 0, G: 0, B: 0 };
        if (r != undefined) {
            bColorize = true;
            rgb.R = r;
        }

        if (g != undefined) {
            bColorize = true;
            rgb.G = g;
        }

        if (b != undefined) {
            bColorize = true;
            rgb.B = b;
        }

        if (!bColorize) {
            rgb = { R: 255, G: 255, B: 255 };
        }

        return {
            status: status,
            position: { x: -x * self.icon.w, y: -y * self.icon.h },
            enableColors: bColorize,
            color: rgb,
            srcId: self.pan,
            size: { h: self.icon.h, w: self.icon.w },
            setSize: { h: self.image.h, w: self.image.w }
        }
    }
    this.getIconByTypeName = function (status,typename,r,g,b) {
        return self.getIconByIndex(status, self.getIconIndexByIconTypeName(typename), r, g, b);
    }
    this.getIconIndexByIconTypeName = function(type){
        var index = self.typename[type];
        if (index == undefined) {
            index = 0;
        }
        return index;
    }
    // Typename map
    this.typename = {
        automatic: 163,
        aux: 150,
        bass: 155,
        bluetooth: 61,
        bluray: 187,
        cd: 186,
        cd_next:115,
        cd_prev:114,
        circle: 146,
        cold: 81,
        comfort: 181,
        disable: 146,
        dvd: 187,
        dvr: 126,
        economy: 180,
        forced: 161,
        home: 169,
        home_in: 129,
        home_out: 130,
        holiday: 95,
        hot: 172,
        in: 112,
        less: 117,
        manual: 162,
        mic: 60,
        mic_in: 78,
        mic_out: 79,
        mix: 83,
        mp3: 58,
        mute: 184,
        night: 138,
        off: 123,
        on: 124,
        one: 100,
        out: 113,
        plus: 116,
        pause: 159,
        power: 155,
        sound: 183,
        summer: 135,
        sun_cloud: 76,
        standby: 129,
        temperature: 125,
        track_next:113,
        track_prev:112,
        treble: 155,
        triangle: 148,
        tuner: 61,
        tv: 185,
        two: 101,
        usb: 73,
        volume: 155,
        water: 84,
        winter: 81,
        work: 130,
        square: 147,
        sun: 135
    };
};

/*!
Color piker
*/
function blrColorPicker(){
    var self = this;
    var m_$dialog = undefined;
    var m_colors = [
        "#FFFFFF","#999999","#333333","#000000",
        "#990000","#009900","#000099","#999900",
        "#990099","#009999","#330901","#013309"
    ];
    this.color = "000000";
    this.onChange = undefined;
    this.onClose = undefined;

    this.show = function($element,color){
        if(m_$dialog == undefined) {
            m_$dialog = $("<div id=\"blrColorPicker\" style=\"position: relative; display: block;\"></div>");
            $("body").append(m_$dialog);

            m_$dialog.colpick({
                layout: 'hex',
                colorScheme: 'dark',
                submit: 0,
                onChange: function (hsb, hex, rgb, el, bySetColor) {
                    self.color = hex;
                    if (self.onChange != undefined) {
                        self.onChange(hsb, hex, rgb, el, bySetColor);
                    }
                },
                onHide: function () {
                    if (self.onClose != undefined) {
                        self.onClose(self.color);
                    }
                    self.onClose = undefined;
                    self.onChange = undefined;
                }
            }).keyup(function () {
                $(this).colpickSetColor(this.value);
            });

            var $colPresets = $(".colpick_hex .colpick_preset");
            for(var i=0; i<m_colors.length; ++i){
                var $li = $("<li></li>");
                var $color = $("<div></div>");
                var $saveBtn = $("<span class='ui-icon ui-icon-disk' title='save'></span>");
                $color.css("background-color",m_colors[i]);
                $li.append($color);
                $li.append($saveBtn);
                $colPresets.append($li);
            }

            $colPresets.on("click","li div", function (ev) {
                var $preset = $(ev.target);
                var $input = $($(this).parent().parent().parent().data("colpick").el);
                $input.val(bigh.textRgb2hex($preset.css("background-color")).substring(1));
                $input.trigger("keyup");
            });
        }
        if($element == undefined) {
            m_$dialog.css({position:"absolute", top: "0px", left: "0px"});
        }else{
            var offset = $element.offset();
            var maxYPos=document.height-210;
            if (offset.top>maxYPos)
            {
                m_$dialog.css({position:"absolute", top: maxYPos, left: offset.left});
            }
            else {
                m_$dialog.css({position:"absolute", top: offset.top, left: offset.left});
            }

        }
        m_$dialog.colpickSetColor(color);
        m_$dialog.click();
        return m_$dialog;
    }

    this.hide = function(){
        if(m_$dialog != undefined) {
            m_$dialog.colpickHide();
        }
    }
}

/*!
Executionstack.
*/
function blrExecutionStack(){
    var self = this;
    var m_progress = 0;
    var m_cancel = false;
    var m_stack = new Array();
    var m_timeouts = new Array();

    var m_$dialog = undefined;
    var m_$progressbar = undefined;

    this.show = function(title){
        m_cancel = false;
        m_progress = 0;
        m_$dialog = $("<div id='executestack-dialog' title='" + title + "'></div>");
        m_$progressbar = $("<div id='executestack-wizard'></div>");
        m_$progressbar.progressbar({ value: 0 });
        m_$dialog.append("</br></br>");
        m_$dialog.append(m_$progressbar);
        $("body").append(m_$dialog);
        m_$dialog.dialog({
            modal: true,
            width:500,
            close: function () {
                m_cancel = true;
                $(this).dialog("close");
                $(this).remove();
            }
        });
        return m_$dialog;
    }

    this.hide = function () {
        if(m_$dialog != undefined){
            m_cancel = false;
            m_progress = 0;
            m_$dialog.remove();
            m_$dialog = undefined;
            m_$progressbar = undefined;
        }
    }

    this.cancel = function () {
        m_cancel = true;
        for(var t=0; t<m_timeouts.length; ++t){
            clearTimeout(m_timeouts[t]);
        }
        m_timeouts = new Array();
        m_stack = new Array();
        self.hide();
    }

    this.push = function (procedure,in_args,out_args) {
        m_stack.push(
            function(){
                out_args = procedure(in_args);
            }
        );
    }

    this.execute = function(msSteps,hideGui,showProgress) {
        if(msSteps == undefined){
            msSteps = 1;
        }

        if(hideGui == undefined){
            hideGui = false;
        }

        if(showProgress == undefined){
            showProgress = true;
        }

        if (m_stack.length > 0) {
            var step = 100 / m_stack.length;
            for (var i = 0; i < m_stack.length; ++i) {
                if (m_cancel) {
                    for(var t=0; t<m_timeouts.length; ++t){
                        clearTimeout(m_timeouts[t]);
                    }
                    m_timeouts = new Array();
                    break;
                }
                var _func = function (procedure,progress,isLast) {
                    return function () {
                        if(m_cancel){
                            for(var t=0; t<m_timeouts.length; ++t){
                                clearTimeout(m_timeouts[t]);
                            }
                            m_timeouts = new Array();
                            return;
                        }


                        procedure();
                        if(m_$progressbar != undefined && showProgress){
                            m_$progressbar.progressbar({ value: progress });
                        }

                        if(isLast && hideGui){
                            self.hide();
                            m_timeouts = new Array();
                        }
                    }
                }
                m_timeouts.push(setTimeout(_func(m_stack[i],(i+1)*step,i == (m_stack.length-1)), msSteps * ++m_progress));
            }
            m_stack = new Array();
        }else{
            if(hideGui){
                self.hide();
            }
        }
    }
}

function blrComponentsVisitor(){
    var self = this;
    var m_components = {
        "combo": application.getComponentsByType("combo"),
        "group": application.getComponentsByType("group"),
        "info": application.getComponentsByType("info"),
        "shutter": application.getComponentsByType("shutter"),
        "slider": application.getComponentsByType("slider"),
        "switch": application.getComponentsByType("switch"),
        "thermostat": application.getComponentsByType("thermostat"),
        "timed-thermostat": application.getComponentsByType("timed-thermostat"),
        "scenario": application.getComponentsByType("scenario"),
        "rgb-light": application.getComponentsByType("rgb-light")
    };

    this.getComponentBy = function
    (
        protocol,
        type,
        params
    )
    {
        var aComponents = m_components[type];
        if (aComponents == undefined) {
            return undefined;
        }
        
        var iEqual = Object.keys(params).length;
        for (var i = 0; i < aComponents.length; ++i) {
            var oNode = aComponents[i];
            var oData = oNode.getData();
            if (oData.getParamVal("gateway").getData().getProtocol() == protocol) {
                // Check params
                var iEqualCount = 0;
                for (var key in params) {
                    if (oData.getParamVal(key) == params[key]) {
                        ++iEqualCount;
                    }
                }
                if (iEqual == iEqualCount) {
                    return oNode;
                }
            }
        }

        return undefined;
    }

}


function blrProfiler(){
    var self = this;
    var m_time = new Date();
    this.begin = function(){
        m_time = new Date();
    }
    this.end = function(){
        var now = new Date();
        return now.getTime()-m_time.getTime();
    }
}


function blrComponentEventData
(
    source,
    $properties,
    node
)
{
    var self = this;
    var m_source = source;
    var m_$properties = $properties;
    var m_node = node;

    this.source = function(){ return m_source; }
    this.$properties = function(){ return m_$properties; }
    this.node = function(){ return m_node; }
    this.gateway = function(){ return m_node.getParamVal("gateway"); }
    this.protocol = function(){ return m_node.getParamVal("gateway").getData().getProtocol(); }
}

function blrUIBuilder() {
    var self = this;
    var m_w = 0;
    var m_h = 0;

    this.setCanvasSize = function (w, h) {
        var canvas = application.getSelectUser().getData().canvas;
        if (w == undefined) {
            m_w = canvas.w;
        } else {
            m_w = w;
        }
        if (h == undefined) {
            m_h = canvas.h;
        } else {
            m_h = h;
        }
    }

    this.demo = function () {
        self.setCanvasSize();

        var oIcon = application.addUIComponent(
            {
                name: name,
                icon: blr.gfxResource.getIconByTypeName(0, "home", 0x99, 0, 0)
            }
        );
         
        var aComponents = new Array();
        for (var i = 0; i < 5; ++i) {
            aComponents.push(application.addComponent("switch"));
        }

        for (var i = 0; i < 3; ++i) {
            var oMap = application.addMapTo(
                oIcon,
                {
                    name: "Zone " + i,
                    icon: blr.gfxResource.getIconByTypeName(0,"comfort",0,0,0x99)
                }
            );

            switch (i) {
                case 0: {
                    var w = m_w / aComponents.length;
                    for (var c = 0; c < aComponents.length; ++c) {
                        application.addComponentToMap(
                            aComponents[c],
                            oMap,
                            {
                                scaleFactor: 1,
                                scaleFactorWidth: 1,
                                scaleFactorHeight: 1,
                                position: { x: w * c, y: 0 }
                            }
                        );
                    }
                } break;
                case 1: {
                    var h = m_h / aComponents.length;
                    for (var c = 0; c < aComponents.length; ++c) {
                        application.addComponentToMap(
                            aComponents[c],
                            oMap,
                            {
                                scaleFactor: 1,
                                scaleFactorWidth: 1,
                                scaleFactorHeight: 1,
                                position: { x: 0, y: h * c }
                            }
                        );
                    }
                } break;
                case 2: {
                    var w = m_w / aComponents.length;
                    var h = m_h / aComponents.length;
                    for (var c = 0; c < aComponents.length; ++c) {
                        application.addComponentToMap(
                            aComponents[c],
                            oMap,
                            {
                                scaleFactor: 1,
                                scaleFactorWidth: 1,
                                scaleFactorHeight: 1,
                                position: { x: w * c, y: h * c }
                            }
                        );
                    }
                } break;
            }
        }
    }
}

function blr(){
    var self = this;
    this.profiler = new blrProfiler();
    //this.componentProperties = new blrComponentProperties();
    this.colorPicker = new blrColorPicker();
    this.executionStack = new blrExecutionStack();
    this.gfxResource = new blrGfxResource();
    this.uiBuilder = new blrUIBuilder();

    this.declarations = undefined;
    this.reloadDeclarations = function(){
        self.declarations = undefined;
        self.declarations = {
            aernova:{
                functions: $.parseJSON( QT.readFile("./declarations/aernova/functions.json") )
            },
            ave:{
                devices: $.parseJSON( QT.readFile("./declarations/ave/devices.json") )
            },
            bticino:{
                functions: $.parseJSON( QT.readFile("./declarations/bticino/functions.json") )
            },
            modbus:{
                functions: $.parseJSON( QT.readFile("./declarations/modbus/functions.json") )
            },
            odic:{
                functions: $.parseJSON( QT.readFile("./declarations/odic/functions.json") )
            },
            vimar:{
                devices: $.parseJSON( QT.readFile("./declarations/vimar/devices.json") )
            },
            vivaldi:{
                devices: $.parseJSON( QT.readFile("./declarations/vivaldi/devices.json") ),
                giovefree: $.parseJSON( QT.readFile("./declarations/vivaldi/giovefree.json") )
            }
        };
    }
}

try {
    var blr = new blr();
    blr.reloadDeclarations();
}catch(err){
    console.error(err);
}