﻿/** Javascript KNX OPC server file parser (OPC file contents is inside window["knx/opc"])
 * 
 */
try{
    console.log("%cStart KNX OPC server file parsing","color:DarkSlateBlue");
    
    var aLines =  window["knx/opc"].split("\n");
    var knxProjectTitle = aLines.shift();

    //alert(knxProjectTitle);
    
    /*var oKnxJson = {
        data: new Array()
    };*/
   var oKnxJson = new Array();
    
    //Parse lines
    while(aLines.length > 0){
        var strLine = aLines.shift();
        if(strLine == ""){
            continue;
        }
        
        var aParameters = strLine.split("\t");
        
        //Get group address parameters
        // [0] -> Group description ([MAIN GROUP NAME].[INTERMEDIATE GROUP NAME].[GROUP ADDRESS])
        // [1] -> Group address name
        // [2] -> Group address type
        // [3] -> Group address level
        
        var aDescription = aParameters[0].split(".");
        var aAddress = aDescription[2].split("/");
        
        //Main group
        var mainGroup = {
            data: "<span>"+ aAddress[0] +"</span>&nbsp;<span class='name'>"+ aDescription[0] +"</span>",
            title: aDescription[0] ,
            state: "open",
            type:aParameters[2],
            attr: { "rel": "knx-main-group" },
            children: new Array()
        };
        
        //Intermediate group
        var intermediateGroup = {
            data: "<span>"+ aAddress[1] +"</span>&nbsp;<span class='name'>"+ aDescription[1] +"</span>",
            title: aDescription[1] ,
            type:aParameters[2],
            //data: aDescription[1],
            //state: "open",
            attr: { "rel": "knx-intermediate-group" },
            children: new Array()
        };
        
        //Group
        var lowerGroup = {
            data: "<span>"+ aAddress[2] +"</span>&nbsp;<span class='name'>"+ aParameters[1] +"</span>",
            //data: aParameters[1],
            title: aParameters[1] ,
            type:aParameters[2],
            attr: {
                "rel": "knx-group",
                "knx-group-address": aDescription[2],
                "title": aDescription[2]
            }

        };
        
        //Find main group
        var bFind = false;
        var mainIndex = 0;
        for(var i=0; i<oKnxJson.length; ++i){
            if(oKnxJson[i].data == mainGroup.data){
                bFind = true;
                mainIndex = i;
                break;
            }
        }
        
        //Push new Main Group element
        if(!bFind){
            mainIndex = (oKnxJson.push(mainGroup) - 1);
        }
        
        //Find intermediate group
        bFind = false;
        var interIndex = 0;
        for(var i=0; i<oKnxJson[mainIndex].children.length; ++i){
            if(oKnxJson[mainIndex].children[i].data == intermediateGroup.data){
                bFind = true;
                interIndex = i;
                break;
            }
        }
        
        //Push new intermediate Group element
        if(!bFind){
            interIndex = (oKnxJson[mainIndex].children.push(intermediateGroup) - 1);
        }
        
        //Push new lower Group element
        oKnxJson[mainIndex].children[interIndex].children.push(lowerGroup);
        
    }//end while
    
    //Write KNX parsing in a file
    //console.log(QT.writeFile("./project/assets/imports/knx/project.json",JSON.stringify(oKnxJson)));
    if(!QT.writeFile("../project/assets/imports/knx/project.json",JSON.stringify(oKnxJson))){
        alert("KNX OPC file import failed!");
        throw "KNX OPC file import failed!";
    }
    //console.log(JSON.stringify(oKnxJson));
    console.log(oKnxJson);
    console.log("---");

    /*
    importazione dei componenti KNX
     */
    /*
    if (application.getGatewaysByProtocol("knx").length==0)
    {
        application.addGateway({ name: "KNX", protocol: "knx" });
    }
    var g=application.getGatewaysByProtocol("knx")[0];

    application.selectGateway(g);
    var mainGroup=application.addComponent({ type: "group", name:"Import"});
    for(var ii=0;ii<oKnxJson.length;ii++)
    {
      // console.log(oKnxJson[ii].title);
        var subComponents=oKnxJson[ii].children;
        var subGroup=application.addComponent({ type: "group", name:oKnxJson[ii].title},mainGroup);

        for(var ii1=0;ii1<subComponents.length;ii1++)
        {
            var subComponents1=subComponents[ii1].children;
            var subGroup1=application.addComponent({ type: "group", name:subComponents[ii1].title},subGroup);


            for(var ii2=0;ii2<subComponents1.length;ii2++) {

                var feed="";
                if (ii2<subComponents1.length-1)
                {
                    var titlefeed=subComponents1[ii2+1].title;
                    console.log(titlefeed);
                    if (titlefeed.indexOf("Feed") > -1) {
                        feed = subComponents1[ii2 + 1].attr["knx-group-address"];
                    }

                }
                var valType=subComponents1[ii2].type;
                var subComponents2 = subComponents1[ii2].children;

                if (valType.indexOf("4 Byte") > -1)
                {
                    if (subComponents1[ii2].title.indexOf("Energia") > -1)
                    {
                        var oPar = {
                            "name": subComponents1[ii2].title,
                            "type": "info",
                            "knx/feedback-address": subComponents1[ii2].attr["knx-group-address"],
                            "knx/DPT": "12.1",
                            "knx/raw-value": true,
                        };
                        application.addComponent(oPar, subGroup1);
                    }
                    else if (subComponents1[ii2].title.indexOf("Potenza") > -1)
                    {
                        var oPar = {
                            "name": subComponents1[ii2].title,
                            "type": "info",
                            "knx/feedback-address": subComponents1[ii2].attr["knx-group-address"],
                            "knx/DPT": "14.0",
                            "knx/raw-value": true,
                        };
                        application.addComponent(oPar, subGroup1);
                    }
                    else if (subComponents1[ii2].title.indexOf("Frequenza") > -1)
                    {
                        var oPar = {
                            "name": subComponents1[ii2].title,
                            "type": "info",
                            "knx/feedback-address": subComponents1[ii2].attr["knx-group-address"],
                            "knx/DPT": "14.0",
                            "knx/raw-value": true,
                        };
                        application.addComponent(oPar, subGroup1);
                    }
                    else if (subComponents1[ii2].title.indexOf("Cos Phi") > -1)
                    {
                        var oPar = {
                            "name": subComponents1[ii2].title,
                            "type": "info",
                            "knx/feedback-address": subComponents1[ii2].attr["knx-group-address"],
                            "knx/DPT": "14.0",
                            "knx/raw-value": true,
                        };
                        application.addComponent(oPar, subGroup1);
                    }
                    else
                    {
                        var oPar = {
                            "name": subComponents1[ii2].title,
                            "type": "info",
                            "knx/feedback-address": subComponents1[ii2].attr["knx-group-address"],
                            "knx/DPT": "12.1",
                            "knx/raw-value": true,
                        };
                        application.addComponent(oPar, subGroup1);
                    }

                }
                if (valType.indexOf("1 Bit") > -1)
                {

                    var oPar = {
                        "name": subComponents1[ii2].title,
                        "type": "switch",
                        "knx/write-address": subComponents1[ii2].attr["knx-group-address"],
                        "knx/feedback-address": feed
                    };

                    application.addComponent(oPar, subGroup1);
                }



                if (feed!="")
                {
                    console.log(feed);
                    ii2=ii2+1;

                }
            }
        }
    }
    */
    //Empty OPC variable
    //window["knx/opc"] = undefined;
    delete window["knx/opc"];
    
    //Open dialog
    $("#ets-project").dialog("open");
    
    console.log("%cStop KNX OPC server file parsing","color:DarkSlateBlue");
}
catch(err){
    console.error(err);
    alert("KNX OPC server file parsing error");
}