/** Javascript KNX OPC server file parser (OPC file contents is inside window["knx/opc"])
 *
 * 17/12/2014 by Matteo Casagrande
 * Audio system implementation, Docking Station and Radio FM
 *
 *
 */
try {
	console.log("%cStart VIMAR By Me XML file parsing v.1.1.1", "color:DarkSlateBlue");
	
	var bFeedbackSimulation = window["vimar"]["feedbackSimulations"];
	var feedbackAddress = 0x5800; // 11/0/0
	var linkAddress = 0x7800; // 15/0/0
	var aGwKnx = application.getGatewaysByProtocol("knx");
	var aGwVimar = application.getGatewaysByProtocol("vimar");

	// Create KNX gateway if not exist
	var oKnxGwNode = (aGwKnx.length > 0) ? aGwKnx[0] : application.addGateway({
		name : "Vimar Knx",
		protocol : "knx"
	});

	// Create Vimar KNX gateway if not exist
	var oVimarGwNode = (aGwVimar.length > 0) ? aGwVimar[0] : application.addGateway({
		name : "Vimar By-Me",
		protocol : "vimar"
	});

	$("#document").trigger("app/load/begin", ["Import Vimar By Me"]);

	//Check
	if (!QT.writeFile("../project/assets/imports/vimar/project.xml", window["vimar"]["xml"])) {
		throw "Vimar By Me file import failed";
	}

	var aComponentsParam = new Array();

	var $project = $(window["vimar"]["xml"]);
	console.log($project);
	var $groups = $project.find("application");
	console.log($groups);
	var aDevices = JSON.parse(QT.readFile("./declarations/vimar/devices.json"));
	console.log(aDevices);
	var vimarOffset_16 = $project.find("configurator").attr("offset");
	console.log(vimarOffset_16);
	var vimarOffset_10 = parseInt(vimarOffset_16.toString(16), 16);

	//Create groups
	var oSwitchNode = application.addComponent({
		type : "group",
		name : _D("Switches")
	});
	var oSliderNode = application.addComponent({
		type : "group",
		name : _D("Sliders")
	});
	var oShutterNode = application.addComponent({
		type : "group",
		name : _D("Shutters")
	});
	var oInfoNode = application.addComponent({
		type : "group",
		name : _D("Infos")
	});
	var oComboNode = application.addComponent({
		type : "group",
		name : _D("Combos")
	});
	var oThermoNode = application.addComponent({
		type : "group",
		name : _D("Thermostat")
	});
	var oScenarioNode = application.addComponent({
		type : "group",
		name : _D("Scenaries")
	});
	var oAudioNode = application.addComponent({
		type : "group",
		name : _D("Media")
	});
	var oPowerNode = application.addComponent({
		type : "group",
		name : _D("Load Control")
	});

	window["vimar"]["unrecognized"] = new Array();

	// Added by Andrea Padovan 26/05/2014
	var vimarScenarioWithoutMainTrue = new Array();
	var vimarScenarioWithoutMainTrueName = new Array();

	//alert("Applications " + $groups.length);
	// for each application node...
	for (var i = 0; i < $groups.length; ++i) {
		var $group = $($groups[i]);
		var $components = $group.find("index");
		var strGroupName = $group.attr("name");

		//alert("Application " + strGroupName + " ID " + $group.attr("id") + " Index nodes " + $components.length);

		//Check components
		if ($components.length < 1) {
			continue;
		}

		//console.error("strGroupName: "+ strGroupName);

		//Parse component
		// for each index node in application node
		for (var j = 0; j < $components.length; ++j) {
			var $component = $($components[j]);
			var strComponentName = $component.attr("index") + "," + $component.attr("label");
			var $devices = $component.find("device");
			var $DPTs = $component.find("datapointtypes datapointtype");
			var $functionalBlock = $devices.find("[main='True']");
			var strPhysicalAddress = $functionalBlock.parents("device").attr("address");
			var oDevice;
			var strDevicePid = $functionalBlock.parents("device").attr("type");
			var strDeviceFid = $functionalBlock.attr("index");
			var aGroupAddresses = new Array();
			var oIconsPanId = application.ResoucesManager.getDefaultIconsPan()["id"];
			var strGroupAddress;
			var strApplicationId = $group.attr("id");
			var strApplicationIdLocalScenario = "5";
			var strApplicationIdGlobalScenario = "4";

			// Implementare formula scenari globali, non ancora implementata.
			if (strApplicationId == strApplicationIdLocalScenario || strApplicationId == strApplicationIdGlobalScenario) {
				var $dataType = $component.find("datapointtype");
				for (var k = 0; k < $dataType.length; ++k) {
					var $refObject = $($dataType[k]);
					if ($refObject.attr("name") == "DPTVimarScene") {
						var $goRefList = $refObject.find("groupobject");
						for (var g = 0; g < $goRefList.length; ++g) {
							var $go = $($goRefList[g]);
							// Update associative map
							var strAddress = $go.attr("address");
							vimarScenarioWithoutMainTrueName[strAddress] = strComponentName;
							//console.error("Scenario " + strAddress + " name " + strComponentName);
							//console.error("Scenario " + $go.attr("address") + " user object with address " + strPhysicalAddress);
						}
					}
				}
				continue;
			} else {
				if ($functionalBlock.length < 1) {
					console.warn("functionalBlock.length < 1 main=True not found Application ID=" + $group.attr("id"));
					continue;
				}

				if (strDevicePid == undefined) {
					console.warn("strDevicePid == undefined Application ID=" + $group.attr("id"));
					continue;
				}

				//Clean zero number to device PID
				while (strDevicePid[0] == "0") {
					strDevicePid = strDevicePid.substring(1);
				}

				//Check if PID exist in Vimar By Me products list and get device
				for (var k = 0; k < aDevices.length; ++k) {
					if (aDevices[k]["pid"] == strDevicePid) {
						oDevice = aDevices[k];
						break;
					}
				}

				if (oDevice == undefined) {
					//TODO Controllare se in continue è corretto
					continue;
					//break;
				}

				//console.warn("Device " + strDevicePid + " Application ID=" + $group.attr("id"));

				//Find lower group addresses as component group address
				for (var k = 0; k < $DPTs.length; ++k) {
					aGroupAddresses.push($($DPTs[k]).find("groupobject").attr("address"));
				}

				//Get group address
				//TODO FORSE QUI PROBLEMA PID 7B
				strGroupAddress = aGroupAddresses.sort()[0];

				if ($functionalBlock.length > 1) {
					console.warn("More than one Functional Block with attribute main='True'");
				}
			}

			// Update refereces to scenaries
			var strAddressesScenario = new Array();
			var $fbDataType = $functionalBlock.find("datapointtype");
			for (var k = 0; k < $fbDataType.length; ++k) {
				var $refObject = $($fbDataType[k]);
				if ($refObject.attr("name") == "DPTVimarScene") {
					var $goRefList = $refObject.find("groupobject");
					for (var g = 0; g < $goRefList.length; ++g) {
						var $go = $($goRefList[g]);
						// Update associative map
						var strAddressScenario = $go.attr("address");
						if (vimarScenarioWithoutMainTrue[strAddressScenario] == undefined) {
							vimarScenarioWithoutMainTrue[strAddressScenario] = new Array();
						}
						vimarScenarioWithoutMainTrue[strAddressScenario].push(strPhysicalAddress);
						strAddressesScenario.push(strAddressScenario);
						//console.error("Scenario " + $go.attr("address") + " user object with address " + strPhysicalAddress);
					}
				}
			}

			//Check scenario (confirm scenario id is always 5)
			if ($group.attr("id") == "4") {
				//Global scenario
				//alert("Global scenaries not ssupported");
				console.warn("Add global scenario");
				continue;
			}


			//console.warn("PID: "+ strDevicePid.toUpperCase());

			/*if(strComponentName != "-----QUESTO-----"){
			continue;
			}*/

			/*console.warn("strComponentName: "+ strComponentName);
			console.warn("strPhysicalAddress: "+ strPhysicalAddress);
			console.warn("aGroupAddresses: "+ aGroupAddresses);
			console.warn("strComponentName: "+ strComponentName);
			console.warn("strComponentName: "+ strComponentName);*/

			//Switch by Vimar PID
			switch(strDevicePid.toUpperCase()) {
			//Info
			case "6E":
				aComponentsParam.push({
					params : {
						"type" : "info",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : strDeviceFid
					},
					parent : oInfoNode
				});

				if (window["vimar/createRelations"]) {

				}

				break;
			//Shutter
			case "62":
			case "86":
			case "75":
				aComponentsParam.push({
					params : {
						"type" : "shutter",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : strDeviceFid
					},
					parent : oShutterNode
				});
				break;
			//Ambient temperature control thermostat
			case "6C":
				//Info temperature
				aComponentsParam.push({
					params : {
						"type" : "info",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -128,
								y : -640
							},
							color : {
								R : 255,
								G : 0,
								B : 0
							},
							srcId : oIconsPanId
						})],
*/
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 8
					},
					parent : oInfoNode
				});

				//Thermostat
				aComponentsParam.push({
					params : {
						"type" : "thermostat",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -256,
								y : -512
							},
							srcId : oIconsPanId
						})],
*/
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 6
					},
					parent : oThermoNode
				});
				
				//Combo boxes
				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oVimarGwNode,
						"name" : strComponentName + " Season",
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : 0,
								y : -512
							},
							color : {
								R : 0,
								G : 0,
								B : 255
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : -128,
								y : -512
							},
							color : {
								R : 255,
								G : 0,
								B : 0
							},
							srcId : oIconsPanId
						})],
*/
						"values" : [{
							"value" : 0,
							"description" : _D("Winter")
						}, {
							"value" : 1,
							"description" : _D("Summer")
						}],
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 3
					},
					parent : oComboNode
				});

				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oVimarGwNode,
						"name" : strComponentName + " Mode",
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -1152,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : 0,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 2,
							position : {
								x : -128,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 3,
							position : {
								x : -256,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 4,
							position : {
								x : -384,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 5,
							position : {
								x : -512,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 6,
							position : {
								x : -640,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 7,
							position : {
								x : -768,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 8,
							position : {
								x : -896,
								y : -1408
							},
							srcId : oIconsPanId
						})],
*/
						"values" : [{
							"value" : 0,
							"description" : _D("Off")
						}, {
							"value" : 1,
							"description" : _D("Forced Off")
						}, {
							"value" : 2,
							"description" : _D("Off Period")
						}, {
							"value" : 3,
							"description" : _D("Antifreeze")
						}, {
							"value" : 4,
							"description" : _D("Night")
						}, {
							"value" : 5,
							"description" : _D("Night Period")
						}, {
							"value" : 6,
							"description" : _D("Manual")
						}, {
							"value" : 7,
							"description" : _D("Manual Period")
						}, {
							"value" : 8,
							"description" : _D("Automatic")
						}],
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 1
					},
					parent : oComboNode
				});

				if(bFeedbackSimulation){ // Create an other thermostat with knx for link with universal gateway
					//Thermostat
					aComponentsParam.push({
						params : {
							"type" : "thermostat",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName,
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : -256,
									y : -512
								},
								srcId : oIconsPanId
							})],
*/
							"knx/virtual-feedback" : true,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress)
						},
						parent : oThermoNode
					});
					linkAddress++;
					
					//Combo boxes
					aComponentsParam.push({
						params : {
							"type" : "combo",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName + " Season",
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : 0,
									y : -512
								},
								color : {
									R : 0,
									G : 0,
									B : 255
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 1,
								position : {
									x : -128,
									y : -512
								},
								color : {
									R : 255,
									G : 0,
									B : 0
								},
								srcId : oIconsPanId
							})],
*/
							"values" : [{
								"value" : 0,
								"description" : _D("Winter")
							}, {
								"value" : 1,
								"description" : _D("Summer")
							}],
							"knx/virtual-feedback" : true,
							"knx/functional-block" : 8,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress)
						},
						parent : oComboNode
					});
					linkAddress++;
					
					aComponentsParam.push({
						params : {
							"type" : "combo",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName + " Mode",
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : -1152,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 1,
								position : {
									x : 0,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 2,
								position : {
									x : -128,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 3,
								position : {
									x : -256,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 4,
								position : {
									x : -384,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 5,
								position : {
									x : -512,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 6,
								position : {
									x : -640,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 7,
								position : {
									x : -768,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 8,
								position : {
									x : -896,
									y : -1408
								},
								srcId : oIconsPanId
							})],
*/
							"values" : [{
								"value" : 0,
								"description" : _D("Off")
							}, {
								"value" : 1,
								"description" : _D("Forced Off")
							}, {
								"value" : 2,
								"description" : _D("Off Period")
							}, {
								"value" : 3,
								"description" : _D("Antifreeze")
							}, {
								"value" : 4,
								"description" : _D("Night")
							}, {
								"value" : 5,
								"description" : _D("Night Period")
							}, {
								"value" : 6,
								"description" : _D("Manual")
							}, {
								"value" : 7,
								"description" : _D("Manual Period")
							}, {
								"value" : 8,
								"description" : _D("Automatic")
							}],
							"knx/virtual-feedback" : true,
							"knx/functional-block" : 8,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress),
						},
						parent : oComboNode
					});
					linkAddress++;
				}

				break;
			//Fan-coil thermostat
			case "90":
				//Info temperature
				aComponentsParam.push({
					params : {
						"type" : "info",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -128,
								y : -640
							},
							color : {
								R : 255,
								G : 0,
								B : 0
							},
							srcId : oIconsPanId
						})],
*/
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 12
					},
					parent : oInfoNode
				});

				//Thermostat
				aComponentsParam.push({
					params : {
						"type" : "thermostat",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -256,
								y : -512
							},
							srcId : oIconsPanId
						})],
*/
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 6
					},
					parent : oThermoNode
				});
				
				//Combo boxes
				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oVimarGwNode,
						"name" : strComponentName + " Season",
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : 0,
								y : -512
							},
							color : {
								R : 0,
								G : 0,
								B : 255
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : -128,
								y : -512
							},
							color : {
								R : 255,
								G : 0,
								B : 0
							},
							srcId : oIconsPanId
						})],
*/
						"values" : [{
							"value" : 0,
							"description" : _D("Winter")
						}, {
							"value" : 1,
							"description" : _D("Summer")
						}],
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 7
					},
					parent : oComboNode
				});

				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oVimarGwNode,
						"name" : strComponentName + " Speed",
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : 0,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 2,
							position : {
								x : -128,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 3,
							position : {
								x : -256,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 4,
							position : {
								x : -384,
								y : -1408
							},
							srcId : oIconsPanId
						})],
*/
						"values" : [{
							"value" : 1,
							"description" : _D("Speed") + "1"
						}, {
							"value" : 2,
							"description" : _D("Speed") + "2"
						}, {
							"value" : 3,
							"description" : _D("Speed") + "3"
						}, {
							"value" : 4,
							"description" : _D("Automatic")
						}],
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 2
					},
					parent : oComboNode
				});

				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oVimarGwNode,
						"name" : strComponentName + " Mode",
/*
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -1152,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : -0,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 2,
							position : {
								x : -128,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 3,
							position : {
								x : -256,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 4,
							position : {
								x : -384,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 5,
							position : {
								x : -512,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 6,
							position : {
								x : -640,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 7,
							position : {
								x : -768,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 8,
							position : {
								x : -896,
								y : -1408
							},
							srcId : oIconsPanId
						})],
*/
						"values" : [{
							"value" : 0,
							"description" : _D("Off")
						}, {
							"value" : 1,
							"description" : _D("Forced Off")
						}, {
							"value" : 2,
							"description" : _D("Off Period")
						}, {
							"value" : 3,
							"description" : _D("Antifreeze")
						}, {
							"value" : 4,
							"description" : _D("Night")
						}, {
							"value" : 5,
							"description" : _D("Night Period")
						}, {
							"value" : 6,
							"description" : _D("Manual")
						}, {
							"value" : 7,
							"description" : _D("Manual Period")
						}, {
							"value" : 8,
							"description" : _D("Automatic")
						}],
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : 1
					},
					parent : oComboNode
				});

				if(bFeedbackSimulation){ // Create an other thermostat with knx for link with universal gateway
					// Thermostat
					aComponentsParam.push({
						params : {
							"type" : "thermostat",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName,
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : -256,
									y : -512
								},
								srcId : oIconsPanId
							})],
*/
							"knx/virtual-feedback" : true,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress)
						},
						parent : oThermoNode
					});
					linkAddress++;
					
					//Combo boxes
					aComponentsParam.push({
						params : {
							"type" : "combo",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName + " Season",
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : 0,
									y : -512
								},
								color : {
									R : 0,
									G : 0,
									B : 255
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 1,
								position : {
									x : -128,
									y : -512
								},
								color : {
									R : 255,
									G : 0,
									B : 0
								},
								srcId : oIconsPanId
							})],
*/
							"values" : [{
								"value" : 0,
								"description" : _D("Winter")
							}, {
								"value" : 1,
								"description" : _D("Summer")
							}],
							"knx/virtual-feedback" : true,
							"knx/functional-block" : 8,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress),
						},
						parent : oComboNode
					});
					linkAddress++;
	
					aComponentsParam.push({
						params : {
							"type" : "combo",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName + " Speed",
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 1,
								position : {
									x : 0,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 2,
								position : {
									x : -128,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 3,
								position : {
									x : -256,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 4,
								position : {
									x : -384,
									y : -1408
								},
								srcId : oIconsPanId
							})],
*/
							"values" : [{
								"value" : 1,
								"description" : _D("Speed") + "1"
							}, {
								"value" : 2,
								"description" : _D("Speed") + "2"
							}, {
								"value" : 3,
								"description" : _D("Speed") + "3"
							}, {
								"value" : 4,
								"description" : _D("Automatic")
							}],
							"knx/virtual-feedback" : true,
							"knx/functional-block" : 8,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress),
						},
						parent : oComboNode
					});
					linkAddress++;
					
					aComponentsParam.push({
						params : {
							"type" : "combo",
							"gateway" : oKnxGwNode,
							"name" : "-> " + strComponentName + " Mode",
/*
							"icons" : [$.extend(true, (new Icon() ), {
								status : 0,
								position : {
									x : -1152,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 1,
								position : {
									x : -0,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 2,
								position : {
									x : -128,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 3,
								position : {
									x : -256,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 4,
								position : {
									x : -384,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 5,
								position : {
									x : -512,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 6,
								position : {
									x : -640,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 7,
								position : {
									x : -768,
									y : -1408
								},
								srcId : oIconsPanId
							}), $.extend(true, (new Icon() ), {
								status : 8,
								position : {
									x : -896,
									y : -1408
								},
								srcId : oIconsPanId
							})],
*/
							"values" : [{
								"value" : 0,
								"description" : _D("Off")
							}, {
								"value" : 1,
								"description" : _D("Forced Off")
							}, {
								"value" : 2,
								"description" : _D("Off Period")
							}, {
								"value" : 3,
								"description" : _D("Antifreeze")
							}, {
								"value" : 4,
								"description" : _D("Night")
							}, {
								"value" : 5,
								"description" : _D("Night Period")
							}, {
								"value" : 6,
								"description" : _D("Manual")
							}, {
								"value" : 7,
								"description" : _D("Manual Period")
							}, {
								"value" : 8,
								"description" : _D("Automatic")
							}],
							"knx/virtual-feedback" : true,
							"knx/functional-block" : 8,
							"knx/write-address" : vimarGroupAdrConverter(linkAddress),
							"knx/feedback-address" : vimarGroupAdrConverter(linkAddress),
						},
						parent : oComboNode
					});
					linkAddress++;
				}

				break;
			//Slider & switch
			case "63":
			case "87":
			case "6F":
			case "7B":
			case "A1":
			case "A2":
			case "A3":
				/*if(strDevicePid.toUpperCase() == "7B"){
				 console.log("strDevicePid: "+ strDevicePid);
				 console.log("strDeviceFid: "+ strDeviceFid);
				 }*/
				aComponentsParam.push({
					params : {
						"type" : "slider",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : strDeviceFid
					},
					parent : oSliderNode
				});

			/*
			//Switch
			aComponentsParam.push({
			params:{
			"type": "switch",
			"gateway": oVimarGwNode,
			"name": strComponentName,
			"vimar/group-address": strGroupAddress,
			"vimar/physical-address": strPhysicalAddress,
			"vimar/device-pid": strDevicePid,
			"vimar/device-fid": strDeviceFid
			},
			parent: oSwitchNode
			});

			console.error(aComponentsParam);

			break;*/
			//Create only switch component
			case "65":
			case "61":
			case "85":
			case "82":
			case "69":
			case "91":
			case "6B":
			case "73":
			case "66":
			case "68":
				aComponentsParam.push({
					params : {
						"type" : "switch",
						"gateway" : oVimarGwNode,
						"name" : strComponentName,
						"vimar/group-address" : strGroupAddress,
						"vimar/physical-address" : strPhysicalAddress,
						"vimar/device-pid" : strDevicePid,
						"vimar/device-fid" : strDeviceFid
					},
					parent : oSwitchNode
				});
				break;
			// KNX DEVICES:
			case "AA":
				var $parentDPTs = $component.find("datapointtypes");
				var switchWriteAdr = parseInt($parentDPTs.find("[name='DPTSwitch'] groupobject").attr("address"), 16);
				var switchReadAdr = parseInt($parentDPTs.find("[name='DPT_Info_Switch'] groupobject").attr("address"), 16);
				var brightWriteAdr = parseInt($parentDPTs.find("[name='DPT_Brightness'] groupobject").attr("address"), 16);
				var brightReadAdr = parseInt($parentDPTs.find("[name='DPT_Info_Brightness'] groupobject").attr("address"), 16);

				aComponentsParam.push({
					params : {
						"type" : "switch",
						"name" : strComponentName,
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(switchWriteAdr),
						"knx/feedback-address" : vimarGroupAdrConverter(switchReadAdr)
					},
					parent : oSwitchNode
				});
				aComponentsParam.push({
					params : {
						"type" : "slider",
						"name" : strComponentName,
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(brightWriteAdr),
						"knx/feedback-address" : vimarGroupAdrConverter(brightReadAdr)
					},
					parent : oSliderNode
				});

				if (strAddressesScenario.length > 0) {// this object is inside a scenario
					// We need to add the switchReadAdr and brightReadAdr addresses
					for (var sa = 0; sa < strAddressesScenario.length; ++sa) {
						var aData = vimarScenarioWithoutMainTrue[strAddressesScenario[sa]];
						aData.pop();
						// We just added
						aData.push("G" + switchReadAdr);
						aData.push("G" + brightReadAdr);
					}
				}
				break;
			// Audio System
			case "9F":
				// Audio DockingStation
				var $parentDPTs = $component.find("datapointtypes");
				var playbackControlWAdr = parseInt($parentDPTs.find("[name='DPTCntrlPBStatus'] groupobject").attr("address"), 16);
				var playbackControlRAdr = parseInt($parentDPTs.find("[name='DPTPBInfoStatus'] groupobject").attr("address"), 16);
				var playbackMenuWAdr = parseInt($parentDPTs.find("[name='DPTCntrlDBMenu'] groupobject").attr("address"), 16);

				var oAudioDockStation = application.addComponent({
					type : "group",
					name : _D(strComponentName + " Docking Station")
				}, oAudioNode);

				/*
				1 Byte
				0 = up
				1 = down
				2 = left
				3 = right
				*/
				// Add Playback Menu commands
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Menu Up",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackMenuWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 0,
					},
					parent : oAudioDockStation
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Menu Down",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackMenuWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 1,
					},
					parent : oAudioDockStation
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Menu Left",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackMenuWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 2,
					},
					parent : oAudioDockStation
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Menu Right",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackMenuWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 3,
					},
					parent : oAudioDockStation
				});

				/*
				1 Byte
				0-1 bits:
				0 = nothing
				1 = loop current song
				2 = loop album

				2-3 bits:
				0 = nothing
				1 = shuffle song
				2 = shuffle album

				4 bit
				0 = pause
				1 = play

				5-6 bits:
				0 = ?
				1 = ?
				2 = prex
				3 = next

				7 = 0
				*/
				// Add Playback commands
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Prev Track",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackControlWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 80,
					},
					parent : oAudioDockStation
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Next Track",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(playbackControlWAdr),
						"knx/functional-block" : 8,
						"knx/scene-value" : 112,
					},
					parent : oAudioDockStation
				});
				break;
			case "9B":
				// Audio Radio FM
				var $parentDPTs = $component.find("datapointtypes");
				var scanFrequencyWAdr = parseInt($parentDPTs.find("[name='DPTScanFrequency'] groupobject").attr("address"), 16);
				var skipMemoryWAdr = parseInt($parentDPTs.find("[name='DPTSkipMemoryFM'] groupobject").attr("address"), 16);

				var oAudioFM = application.addComponent({
					type : "group",
					name : _D(strComponentName + " Radio FM")
				}, oAudioNode);
				// Scan Frequency
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Scan Prev",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(scanFrequencyWAdr),
						"knx/functional-block" : 6,
						"knx/scene-value" : 0,
					},
					parent : oAudioFM
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Scan Next",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(scanFrequencyWAdr),
						"knx/functional-block" : 6,
						"knx/scene-value" : 1,
					},
					parent : oAudioFM
				});
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Memory Prev",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(skipMemoryWAdr),
						"knx/functional-block" : 6,
						"knx/scene-value" : 0,
					},
					parent : oAudioFM
				});
				// Skip Memory
				aComponentsParam.push({
					params : {
						"type" : "scenario",
						"name" : "Memory Next",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(skipMemoryWAdr),
						"knx/functional-block" : 6,
						"knx/scene-value" : 1,
					},
					parent : oAudioFM
				});

				break;
			case "99":
				// Audio Zone
				var $parentDPTs = $component.find("datapointtypes");
				var onOffAdr = parseInt($parentDPTs.find("[name='DPTOnOff'] groupobject").attr("address"), 16);
				var volumeAdr = parseInt($parentDPTs.find("[name='DPT_Volume_Scaling'] groupobject").attr("address"), 16);
				var channelAdr = parseInt($parentDPTs.find("[name='DPTChannel'] groupobject").attr("address"), 16);

				var oAudioZone = application.addComponent({
					type : "group",
					name : _D(strComponentName)
				}, oAudioNode);

				aComponentsParam.push({
					params : {
						"type" : "switch",
						"name" : "On - Off",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(onOffAdr),
						"knx/feedback-address" : vimarGroupAdrConverter(onOffAdr)
					},
					parent : oAudioZone
				});
				aComponentsParam.push({
					params : {
						"type" : "slider",
						"name" : "Volume",
						"gateway" : oKnxGwNode,
						"knx/write-address" : vimarGroupAdrConverter(volumeAdr),
						"knx/feedback-address" : vimarGroupAdrConverter(volumeAdr),
						"knx/range" : 0
					},
					parent : oAudioZone
				});
				/*
				 1 Byte
				 0 = DockStation
				 1 = Radio
				 3 = IR
				 */
				aComponentsParam.push({
					params : {
						"type" : "combo",
						"gateway" : oKnxGwNode,
						"name" : "Sources",
						"icons" : [$.extend(true, (new Icon() ), {
							status : 0,
							position : {
								x : -1152,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 1,
							position : {
								x : -0,
								y : -1408
							},
							srcId : oIconsPanId
						}), $.extend(true, (new Icon() ), {
							status : 2,
							position : {
								x : -128,
								y : -1408
							},
							srcId : oIconsPanId
						})],
						"values" : [{
							"value" : 0,
							"description" : _D("Docking Station")
						}, {
							"value" : 1,
							"description" : _D("Radio")
						}, {
							"value" : 3,
							"description" : _D("IR")
						}],
						"knx/write-address" : vimarGroupAdrConverter(channelAdr),
						"knx/feedback-address" : vimarGroupAdrConverter(channelAdr),
						"knx/functional-block" : 8
					},
					parent : oAudioZone
				});

				if (strAddressesScenario.length > 0) {// this object is inside a scenario
					// We need to add the switchReadAdr and brightReadAdr addresses
					for (var sa = 0; sa < strAddressesScenario.length; ++sa) {
						var aData = vimarScenarioWithoutMainTrue[strAddressesScenario[sa]];
						aData.pop();
						// We just added
						aData.push("G" + onOffAdr);
						aData.push("G" + volumeAdr);
						aData.push("G" + channelAdr);
					}
				}
				break;
			case "B1":
			case "B0": // Controllo Carichi
				//alert("Controllo carichi");
				var $parentDPTs = $component.find("datapointtypes");
				var activePowerAdr = parseInt($parentDPTs.find("[name='DPT_PotenzaAttiva'] groupobject").attr("address"), 16);
				var reactivePowerAdr = parseInt($parentDPTs.find("[name='DPT_PotenzaReattiva'] groupobject").attr("address"), 16);
				var absoluteEnergyAdr = parseInt($parentDPTs.find("[name='DPT_Energia_Assoluta'] groupobject").attr("address"), 16);
				var partialEnergyAdr = parseInt($parentDPTs.find("[name='DPT_Energia_Parziale'] groupobject").attr("address"), 16);

				if(!isNaN(activePowerAdr)){
					aComponentsParam.push({
						params : {
							"type" : "info",
							"gateway" : oKnxGwNode,
							"name" : strComponentName + " " + _D("Active Power"),
							"knx/feedback-address" : vimarGroupAdrConverter(activePowerAdr),
							"knx/DPT" : "14.36"
						},
						parent : oPowerNode
					});
				}
				
				if(!isNaN(reactivePowerAdr)){
					aComponentsParam.push({
						params : {
							"type" : "info",
							"gateway" : oKnxGwNode,
							"name" : strComponentName + " " + _D("Reactive Power"),
							"knx/feedback-address" : vimarGroupAdrConverter(reactivePowerAdr),
							"knx/DPT" : "14.36"
						},
						parent : oPowerNode
					});
				}
				
				if(!isNaN(absoluteEnergyAdr)){
					aComponentsParam.push({
						params : {
							"type" : "info",
							"gateway" : oKnxGwNode,
							"name" : strComponentName + " " + _D("Energy Absolute"),
							"knx/feedback-address" : vimarGroupAdrConverter(absoluteEnergyAdr),
							"knx/DPT" : "12.1"
						},
						parent : oPowerNode
					});
				}
				
				if(!isNaN(partialEnergyAdr)){
					aComponentsParam.push({
						params : {
							"type" : "info",
							"gateway" : oKnxGwNode,
							"name" : strComponentName + " " + _D("Energy Partial"),
							"knx/feedback-address" : vimarGroupAdrConverter(partialEnergyAdr),
							"knx/DPT" : "12.1"
						},
						parent : oPowerNode
					});
				}
				break;
			default:
				console.warn("VIMAR Component type " + strDevicePid.toUpperCase() + " is not declared");
				window["vimar"]["unrecognized"].push({
					"name" : strComponentName,
					"gateway" : oVimarGwNode,
					"vimar/group-address" : strGroupAddress,
					"vimar/physical-address" : strPhysicalAddress,
					"vimar/device-pid" : strDevicePid,
					"vimar/device-fid" : strDeviceFid
				});
				break;

			}//end switch

		}//end inner for

	}//end outer for

	// Remove duplicates
	for (var key in vimarScenarioWithoutMainTrue) {
		var aData = vimarScenarioWithoutMainTrue[key];
		vimarScenarioWithoutMainTrue[key] = aData.filter(function(elem, pos) {
			return aData.indexOf(elem) == pos;
		});

		//alert("Create scenario " + key + " with name " + vimarScenarioWithoutMainTrueName[key]);
		//console.error("Create scenario " + key + " with name " + vimarScenarioWithoutMainTrueName[key]);

		{
			//Local scenario
			var value = ( parseInt(key.toString(16), 16)) - vimarOffset_10;
			aComponentsParam.push({
				params : {
					"type" : "scenario",
					"gateway" : oVimarGwNode,
					"name" : vimarScenarioWithoutMainTrueName[key],
					"vimar/group-address" : key,
					"vimar/value" : value,
					"vimar/physical-addresses" : vimarScenarioWithoutMainTrue[key].join(",")
				},
				parent : oScenarioNode
			});
		}
	}

	//Create group (whit busy process technique)

	window["vimar"]["process"] = {
		index : 0,
		limit : aComponentsParam.length,
		busy : false,
		callback : function() {
			if (oSwitchNode.children.length < 1) {
				application.removeComponent(oSwitchNode);
			}
			if (oSliderNode.children.length < 1) {
				application.removeComponent(oSliderNode);
			}
			if (oShutterNode.children.length < 1) {
				application.removeComponent(oShutterNode);
			}
			if (oInfoNode.children.length < 1) {
				application.removeComponent(oInfoNode);
			}
			if (oComboNode.children.length < 1) {
				application.removeComponent(oComboNode);
			}
			if (oThermoNode.children.length < 1) {
				application.removeComponent(oThermoNode);
			}
			if (oScenarioNode.children.length < 1) {
				application.removeComponent(oScenarioNode);
			}
			if (oPowerNode.children.length < 1){
				application.removeComponent(oPowerNode);
			}

			// Audio nodes
			var aAudioChildToRemove = new Array();
			for (var i = 0; i < oAudioNode.children.length; ++i) {
				if (oAudioNode.children[i].children.length < 1) {
					aAudioChildToRemove.push(oAudioNode.children[i]);
				}
			}
			for (var i = 0; i < aAudioChildToRemove.length; ++i) {
				application.removeComponent(aAudioChildToRemove[i]);
			}
			if (oAudioNode.children.length < 1) {
				application.removeComponent(oAudioNode);
			}

			//Empty Vimar XML variable
			delete window["vimar"];

			$(document).trigger("app/load/end");

			console.log("%cStop VIMAR By Me XML file parsing", "color:DarkSlateBlue");
		}
	};

	$(document).trigger("app/load/end");
	$(document).trigger("app/load/begin", [_D("Creating components"), "bar"]);

	//console.log(aComponentsParam);
	if (aComponentsParam.length < 1) {
		//console.warn("Empty Vimar project");
		$(document).trigger("app/warning", "Empty Vimar project");
		window["vimar"]["process"]["callback"]();
	} else {
		var process = setInterval(function() {
			if (!window["vimar"]["process"]["busy"]) {
				window["vimar"]["process"]["busy"] = true;
				//console.error(window["vimar"]["process"]["index"]);

				$("#loader").find(".progressbar").progressbar("value", (window["vimar"]["process"]["index"] * 100 / window["vimar"]["process"]["limit"]), 10);

				//Process
				var exist = application.checkComponentExist(aComponentsParam[window["vimar"]["process"]["index"]].params);
				
				if (exist == false) {
					//console.error(aComponentsParam[ window["vimar"]["process"]["index"] ].params);
					var oSourceNode = application.addComponent(aComponentsParam[window["vimar"]["process"]["index"]].params, aComponentsParam[window["vimar"]["process"]["index"]].parent);
					//console.log("Create: "+ aComponentsParam[ window["vimar"]["process"]["index"] ].params["name"]);
					//alert(window["vimar"]["createRelations"]);
					//Create KNX Feedback if relations is flagged
					if (window["vimar"]["createRelations"]) {
						
						/* var oKnxComponent = {
						 gateway: ["vimar"]["gateway"]["knx"],
						 name: aComponentsParam[ window["vimar"]["process"]["index"] ].params.name +" (KNX)"
						 };

						 var oNewParams = $.extend(true,{},aComponentsParam[ window["vimar"]["process"]["index"] ].params,oKnxComponent);
						 var oDestinationNode = application.addComponent(oNewParams,aComponentsParam[ window["vimar"]["process"]["index"] ].parent);

						 application.addRelation({ source:oSourceNode, destination:oDestinationNode }); */
					}
					//TODO Controllare protocollo, se non è Vimar non aggiungere questo parametro
					var oGateway = oSourceNode.getData().getParamVal("gateway").getData();
					if (bFeedbackSimulation && oGateway.getProtocol() == "vimar") {
						var oComponent = oSourceNode.getData();
						//Set additional parameters
						$.publish("/model/components/" + oComponent.id + "/update/parameter", [oComponent, "vimar/enable-sfbk", bFeedbackSimulation]);
						$.publish("/model/components/" + oComponent.id + "/update/parameter", [oComponent, "vimar/sfbk", vimarGroupAdrConverter(feedbackAddress)]);

						feedbackAddress++;
					}
				}/*else{
					console.error("DEBUG");
					console.error(aComponentsParam[window["vimar"]["process"]["index"]].params);
				}*/

				if (++window["vimar"]["process"]["index"] >= window["vimar"]["process"]["limit"]) {
					clearInterval(process);
					window["vimar"]["process"]["callback"]();
					return;
				}
				window["vimar"]["process"]["busy"] = false;
			}
		}, 1);
	}//end else
} catch(err) {
	console.error(err);
	alert("VIMAR By Me XML file parsing error");
}